Subject: Re: _High_ CPU usage while routing (mostly) small UDP packets

From: Karsten Desler <[email-masked]>
Date: Wed, 8 Dec 2004 14:08:45 +0100

* Willy Tarreau wrote:
> On Tue, Dec 07, 2004 at 12:21:39PM +0100, Karsten Desler wrote:
>  
> > > I also notice that a lot of time is spent allocating
> > > and freeing the packet buffers (and possible hidden
> > > time due to cache misses due to allocating on one
> > > CPU and freeing on another?).
> > > How many [RT]xDescriptors do you have configured by the way?
> > 
> > 256. I increased them to 1024 shortly after the profiling run, but
> > didn't notice any change in the cpu usage (will try again with cyclesoak).
> 
> Have you checked the interrupts rate ? I had an e1000 eating many CPU cycles
> because it would generate 50000 interrupts/s. Passing the module
> InterruptThrottleRate=5000 definitely calmed it down, and more than doubled
> the data rate.

I was running mit ITR=3000, but as a test to see if NAPI works, I
disabled ITR on eth0 bringing the int/s rate up to 50k.
Is that normal? I always though NAPI was supposed to kick in way earlier.
Anyways, I'm going to try different ITR settings to see if they make any
difference.

Cheers,
 Karsten